#!/usr/bin/ruby
# simple ruby qmf agent for the stress test

$: << File.expand_path(File.dirname(__FILE__) + '/../lib')

#require 'rubygems'
require 'optparse'

require 'common'
require 'schema_parser'
require 'agent'
require 'object_bank'
require 'stress_factory'


def main()
    # setup cmd line options
    opts = OptionParser.new do |opts|
      opts.banner = "Usage: agent.rb [options]"

      opts.on("-h", "--help", "Print this help message") do
         puts opts
         exit
      end

    end

    # parse cmd line
    begin
      opts.parse!(ARGV)
    rescue OptionParser::InvalidOption => e
      puts opts
      puts e.to_s
      exit
    end

    # create new object bank which objects will be retrieved from
    obj_bank = ObjectBank.new

    # populate object bank w/ some dummy data
    StressFactory.populate :bank => obj_bank, :num => 20

    # create qmf agent, dispatch object / method requests to bank
    agent = StressAgent.new(File.dirname(__FILE__) + '/../../stress_agent/src/stress_agent_schema.xml')
    agent.dispatch_to obj_bank

    # run agent
    agent.mainloop
end

main()
