# logger support
require 'logger'

class Logger
  def format_message(severity, timestamp, progname, msg)
    "#{severity} #{timestamp} (#{$$}) #{msg}\n"
  end
end

module StressLogger
  private
    LOG_LEVEL = ::Logger::DEBUG # FATAL ERROR WARN INFO DEBUG

    def self._instantiate_logger
       unless defined? @@logger
         @@logger = ::Logger.new(STDOUT)
         @@logger.level = LOG_LEVEL
       end 
    end 

  public
    def self.method_missing(method_id, *args)
       _instantiate_logger
       @@logger.send(method_id, args)
    end 
    def self.logger
       _instantiate_logger
       @@logger
    end
end
