#!/usr/bin/ruby
# simple ruby qmf agent for the stress test

$: << File.expand_path(File.dirname(__FILE__) + '/../lib')

require 'rubygems'
require 'optparse'
require 'spqr/spqr'
require 'spqr/app'

require 'common'
require 'object_bank'
require 'managed'

def main()
    # setup cmd line options
    opts = OptionParser.new do |opts|
      opts.banner = "Usage: agent.rb [options]"

      opts.on("-h", "--help", "Print this help message") do
         puts opts
         exit
      end

    end

    # parse cmd line
    begin
      opts.parse!(ARGV)
    rescue OptionParser::InvalidOption => e
      puts opts
      puts e.to_s
      exit
    end

    # populate the object bank w/ some test data
    (0...20).each { |i|
      obj = i % 2 == 0 ? Stress.new : TestObject.new # TODO create some attr values
      ObjectBank.instance.add_obj obj
    }
    
    # start the qmf agent via spqr
    app = SPQR::App.new
    app.register Stress, TestObject
    app.main
end

main()
