# defines managed objects for the stress spqr test

# define classes corresponding to stress schema
class Stress
  include SPQR::Manageable

  qmf_package_name "com.redhat.stress_agent"

  qmf_property :hostname, :lstr

  def self.find_all
     ObjectBank.instance.get_objs :klass => Stress
  end

  def self.find_by_id(id)
     ObjectBank.instance.get_objs :klass  => Stress,
                                  :obj_id => id
  end
end

class TestObject
  include SPQR::Manageable

  qmf_package_name "com.redhat.stress_agent"

  qmf_property :object_index,  :int
  qmf_property :load_avg,      :int
  qmf_property :settable_str,  :int
  qmf_property :stress_parent, :int

  def crypt(key, salt, passwd)
    # TODO
  end

  expose :crypt do |args|
    args.declare :key,    :lstr, :in
    args.declare :salt,   :lstr, :in
    args.declare :passwd, :lstr, :out
  end

  def self.find_all
     ObjectBank.instance.get_objs :klass => TestObject
  end

  def self.find_by_id(id)
     ObjectBank.instance.get_objs :klass  => TestObject,
                                  :obj_id => id
  end

end
