# simple object bank for qmf usage 
# change implementation to pull objects from whatever backend you need

require 'singleton'

class ObjectBank
   include Singleton

   def initialize
     StressLogger.debug "object bank initialized"
     @objects = []
   end

   def add_obj(obj)
     @objects.push obj unless obj.nil? || @objects.include?(obj)
     StressLogger.debug "adding #{obj} to bank"
   end

   def get_objs(args = {})
      klass  = args.has_key?(:klass)  ? args[:klass]  : nil
      obj_id = args.has_key?(:obj_id) ? args[:obj_id] : nil
      obj    = args.has_key?(:obj)    ? args[:obj]    : nil
      qmf_obj_id = args.has_key?(:qmf_obj_id) ? args[:qmf_obj_id] : nil
      StressLogger.debug "get obj called w/ klass:#{klass} obj_id:#{obj_id} obj:#{obj} qmf_obj_id:#{qmf_obj_id}"

      if !obj.nil?
        return @objects.find { |ob| ob == obj }
      elsif !klass.nil?
        return @objects.find_all { |ob| klass == klass }
      elsif !klass.nil? && !obj_id.nil?
        return @objects.find { |obj| obj.klass == klass && obj.id == obj_id }
      elsif !qmf_obj_id.nil?
        return @objects.find { |obj| obj.qmf_obj_id == qmf_obj_id }
      end
   end
end
