
#include <qpid/management/Manageable.h>
#include <qpid/management/ManagementObject.h>
#include <qpid/agent/ManagementAgent.h>
#include <qpid/client/ConnectionSettings.h>
#include <qpid/sys/Mutex.h>

#include "Package.h"
#include "Stress.h"

#include "Test.h"

#include <unistd.h>
#include <cstdlib>
#include <iostream>
#include <sstream>

using namespace qpid::management;
using namespace qpid::sys;
using namespace qpid::client;
using namespace std;
using qpid::management::ManagementObject;
using qpid::management::Manageable;
using qpid::management::Args;
using qpid::sys::Mutex;


class StressAgent : public Manageable
{
    string name;
    ManagementAgent *agent;
    qmf::com::redhat::stress_agent::Stress *mgmtObject;

    std::vector<Test*> test_objects;

public:

    StressAgent(ManagementAgent* agent, string _name);
    ~StressAgent();

    ManagementObject* GetManagementObject(void) const
    { return mgmtObject; }

    void do_loop();
    void create_test_objects(int test_count);

    status_t ManagementMethod (uint32_t methodId, Args& args, std::string &errstr);
};


